org 0
jmp start;

org 03h
jmp error_interrupt;

org 0bh
jmp timer0;

org 13h;
jmp error_interrupt;

org 23h;
jmp error_interrupt;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Nachalo programmi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
start:
  mov TMOD,#1;
  mov tl0,#low(-16960);
  mov th0,#high(-16960);
  mov r2,#16
  mov ie,#10000010b;
  SETB tr0;

  ;vipolnyat kakie libo deystviya
  mov r5,#0;

  loop: 
    inc r5;
    sjmp loop
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Konec glavnoy programmi
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
timer0:
  djnz r2,exit;
  clr tr0;
  mov tl0,#low(-16960);
  mov th0,#high(-16960);
  mov r2,#16;
  setb tr0;

  jb T0, calculate;;Esli signal est, to perehod na calculate
    mov a,r7;
    jnz exit_and_send_result;Esli r7<>0 to znachit vichisleniya bili soversheni i resultat 
            ;hranitsya v r7. EGO NELZYA PRTIT!!!
    mov r7,#(10011001b);Zdes zapishem 99, dalee on uvelichitsya na 1  i stanet=0;
calculate:
    mov a,r7;
    add a,#1;
    da a;
    mov r7,a;
;    inc r7; esli est signal, to uvelichivaem r7
  exit:
    setb tr0;
    reti;

exit_and_send_result:
   clr tr0; Ostanavlivaem prerivaniye tr0;
   mov p1,r7; resultat vidaem v port p1;
   reti; Vozvrat. Prerivaniye tr0 bolshe ne budet;


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Oshibocno ustanovleno prerivaniye
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
error_interrupt:
  jmp loop;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;Konec fayla
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

end
